using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using Microsoft.Win32;
using System.Threading;
using System.Text;
using System.Xml;

namespace MSGClient_Updated
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>

	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListBox lstFriend;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtChat;
		private System.Windows.Forms.Button btnChat;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtStatus;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox cmbStatus;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtFriend;
		private System.Windows.Forms.Button btnFriend;
		private System.Windows.Forms.Button btnStatus;
                private Socket m_client;
                private Thread m_comm;
                private string[] m_stringList;
                private ArrayList m_chatWindows;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuItmLogIn;
		private System.Windows.Forms.MenuItem mnuItmLogOut;
		private System.Windows.Forms.MenuItem mnuItmExit;
		private System.Windows.Forms.MenuItem menuItem4;
                private System.Threading.Timer m_resendTimer;
		private System.Windows.Forms.Button btnRemFriend;
                private string m_user;
                private System.Threading.Timer m_alive;

                public struct StatusData{
                public string mName;
                public string mNum;

                public StatusData(string name,string num){
                	this.mName=name;
                        this.mNum=num;
                }
                public override string ToString(){
                	return this.mName;
                }
                }

                public struct FriendData{
                public string mName;
                public string mNum;

                public FriendData(string name,string num){
                	this.mName=name;
                        this.mNum=num;
                }
                public override string ToString(){
                	return this.mName+" ("+this.mNum+")";
                }
                }
		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.lstFriend = new System.Windows.Forms.ListBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnChat = new System.Windows.Forms.Button();
			this.txtChat = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnStatus = new System.Windows.Forms.Button();
			this.cmbStatus = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.btnFriend = new System.Windows.Forms.Button();
			this.txtFriend = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuItmLogIn = new System.Windows.Forms.MenuItem();
			this.mnuItmLogOut = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.mnuItmExit = new System.Windows.Forms.MenuItem();
			this.btnRemFriend = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// lstFriend
			// 
			this.lstFriend.Location = new System.Drawing.Point(296, 0);
			this.lstFriend.Name = "lstFriend";
			this.lstFriend.Size = new System.Drawing.Size(168, 277);
			this.lstFriend.TabIndex = 0;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnChat);
			this.groupBox1.Controls.Add(this.txtChat);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Location = new System.Drawing.Point(16, 256);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 72);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Start a New Chat";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			//
			// btnChat
			// 
			this.btnChat.Location = new System.Drawing.Point(160, 24);
			this.btnChat.Name = "btnChat";
			this.btnChat.Size = new System.Drawing.Size(80, 40);
			this.btnChat.TabIndex = 2;
			this.btnChat.Text = "Start Chatting";
			// 
			// txtChat
			// 
			this.txtChat.Location = new System.Drawing.Point(40, 32);
			this.txtChat.Name = "txtChat";
			this.txtChat.Size = new System.Drawing.Size(104, 20);
			this.txtChat.TabIndex = 1;
			this.txtChat.Text = "textBox1";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "User:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnStatus);
			this.groupBox2.Controls.Add(this.cmbStatus);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.txtStatus);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Location = new System.Drawing.Point(16, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 120);
			this.groupBox2.TabIndex = 2;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Status";
			// 
			// btnStatus
			// 
			this.btnStatus.Location = new System.Drawing.Point(96, 88);
			this.btnStatus.Name = "btnStatus";
			this.btnStatus.Size = new System.Drawing.Size(80, 24);
			this.btnStatus.TabIndex = 4;
			this.btnStatus.Text = "Set Status";
			// 
			// cmbStatus
			// 
			this.cmbStatus.Location = new System.Drawing.Point(96, 56);
			this.cmbStatus.Name = "cmbStatus";
			this.cmbStatus.Size = new System.Drawing.Size(168, 21);
			this.cmbStatus.TabIndex = 3;
			this.cmbStatus.Text = "comboBox1";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(88, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Change Status:";
			// 
			// txtStatus
			// 
			this.txtStatus.Location = new System.Drawing.Point(96, 24);
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.ReadOnly = true;
			this.txtStatus.Size = new System.Drawing.Size(168, 20);
			this.txtStatus.TabIndex = 1;
			this.txtStatus.Text = "textBox2";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 23);
			this.label2.TabIndex = 0;
			this.label2.Text = "Current Status:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.btnFriend);
			this.groupBox3.Controls.Add(this.txtFriend);
			this.groupBox3.Controls.Add(this.label4);
			this.groupBox3.Location = new System.Drawing.Point(16, 152);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(272, 96);
			this.groupBox3.TabIndex = 3;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Request a New Friend";
			this.groupBox3.Enter += new System.EventHandler(this.groupBox3_Enter);
			// 
			// btnFriend
			// 
			this.btnFriend.Location = new System.Drawing.Point(104, 56);
			this.btnFriend.Name = "btnFriend";
			this.btnFriend.Size = new System.Drawing.Size(72, 24);
			this.btnFriend.TabIndex = 2;
			this.btnFriend.Text = "Add Friend";
			// 
			// txtFriend
			//
			this.txtFriend.Location = new System.Drawing.Point(112, 24);
			this.txtFriend.Name = "txtFriend";
			this.txtFriend.Size = new System.Drawing.Size(144, 20);
			this.txtFriend.TabIndex = 1;
			this.txtFriend.Text = "textBox3";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 24);
			this.label4.TabIndex = 0;
			this.label4.Text = "Enter Username:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.mnuItmLogIn,
						this.mnuItmLogOut,
						this.menuItem4,
						this.mnuItmExit});
			this.menuItem1.Text = "&File";
			// 
			// mnuItmLogIn
			// 
			this.mnuItmLogIn.Index = 0;
			this.mnuItmLogIn.Text = "&Login";
			// 
			// mnuItmLogOut
			// 
			this.mnuItmLogOut.Index = 1;
			this.mnuItmLogOut.Text = "&LogOut";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			//
			// mnuItmExit
			// 
			this.mnuItmExit.Index = 3;
			this.mnuItmExit.Text = "&Exit";
			// 
			// btnRemFriend
			//
			this.btnRemFriend.Location = new System.Drawing.Point(296, 288);
			this.btnRemFriend.Name = "btnRemFriend";
			this.btnRemFriend.Size = new System.Drawing.Size(168, 32);
			this.btnRemFriend.TabIndex = 4;
			this.btnRemFriend.Text = "Remove Friend";
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 334);
			this.Controls.Add(this.btnRemFriend);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.lstFriend);
			this.Menu = this.mainMenu1;
			this.Name = "WinForm";
			this.Text = "Instant Message Client";
			this.Load += new System.EventHandler(this.WinForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new WinForm());
		}

		private void WinForm_Load(object sender, System.EventArgs e) {
                        //Get Server ID
                        m_chatWindows=new ArrayList();
                        m_stringList= new string[256];
                        RegistryKey key=Registry.LocalMachine;
                        key=key.OpenSubKey("Software\\BazSoft\\MSGClient");
                        WinForm3 frm2=new WinForm3();
                        if(key==null){
                        	frm2.ShowDialog();
                                key=Registry.LocalMachine.OpenSubKey("Software\\BazSoft\\MSGClient");
                        }
                        string server = key.GetValue("Server").ToString();
                        if(server==null){
                        	frm2.ShowDialog();
				server = key.GetValue("Server").ToString();
                        }
                        bool repeat=true;
                        while(repeat){
                        	try{IPAddress ip=IPAddress.Parse(server);
                                        m_client=new Socket(ip.AddressFamily,SocketType.Stream,ProtocolType.Tcp);
                                        IPEndPoint ep = new IPEndPoint(ip,31423);
                                        m_client.Connect(ep);
                                        repeat=false;
                        	}
                        	catch(Exception e3){
                        		try{IPHostEntry iphe=Dns.Resolve(server);
                                        IPAddress ip=iphe.AddressList[0];
                                        m_client=new Socket(ip.AddressFamily,SocketType.Stream,ProtocolType.Tcp);
                                        IPEndPoint ep=new IPEndPoint(ip,31423);
                                        m_client.Connect(ep);
                                         }
                        		catch (Exception e2){
                                		switch(MessageBox.Show("The Client cannot connect to the Server. Make sure your LAN, Internet connection or however you connect to the server is working properly."+e2.ToString()+"\n\n Do you want to re-enter the server details and Try Again? (No - Try again without changing settings, Cancel - Quit)","ERROR: Cannot Connect to Server",MessageBoxButtons.YesNoCancel,MessageBoxIcon.Error)){
                                                        case DialogResult.Yes:
                                                	frm2 = new WinForm3();
                                                        frm2.ShowDialog();
							server = key.GetValue("Server").ToString();
                                                        break;
                                                        case DialogResult.Cancel:
                                                        repeat=false;
                                                        this.Close();
                                                        break;
                                                }
                               	 	}
                        	}
                        }
                        m_alive = new System.Threading.Timer(new TimerCallback (KeepAlive),null,10000,10000);

                        lstFriend.Enabled=false;
                        txtChat.Enabled=false;
                        btnChat.Enabled=false;
                        txtStatus.Enabled=false;
                        btnStatus.Enabled=false;
                        cmbStatus.Enabled=false;
                        txtFriend.Enabled=false;
                        btnFriend.Enabled=false;
                        mnuItmLogOut.Enabled=false;
                        mnuItmLogIn.Enabled=true;
                        btnRemFriend.Enabled=false;


		}

		private void groupBox1_Enter(object sender, System.EventArgs e) {

		}

		private void groupBox3_Enter(object sender, System.EventArgs e) {

		}

		private void btnClose_Click(object sender, System.EventArgs e) {

                        m_resendTimer.Change(Timeout.Infinite,Timeout.Infinite);
                        m_alive.Change(Timeout.Infinite,Timeout.Infinite);
                        m_resendTimer=null;
                        m_alive=null;
			Close();
		}
                private void SendToServer(string msg,bool addd){
                         if(m_client !=null){
                                try {
                	 		ASCIIEncoding asc = new ASCIIEncoding();
                         		byte[] bytes=asc.GetBytes(msg);
                                        System.Diagnostics.Debug.WriteLine("Byte array created: Text = "+asc.GetString(bytes)+"\nCount: "+bytes.Length.ToString());
					m_client.Send(bytes);
                                        System.Diagnostics.Debug.WriteLine("Bytes Sent");
                                        if(addd){
                                                System.Diagnostics.Debug.WriteLine("Adding to Resend List");
                                        	AddToStringList(msg);
                                                System.Diagnostics.Debug.WriteLine("Message Added");
                                        }
                                }
                                catch (Exception e){
                                	MessageBox.Show("ERROR: There has been an error in the transfer of the following message to the server:\n\n"+msg+"Reason: "+e.Message+"\n\nFull Error Text: "+e.ToString(),"ERROR: Could not Send Message",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                }
                          }

                }
                private void CommReceive(){
                        byte [] bytes = new byte[512];
                        ASCIIEncoding asc = new ASCIIEncoding();
                        XmlDocument xml = new XmlDocument();
			while(true){
                		m_client.Receive(bytes);
                                string msg=asc.GetString(bytes);
                                if(!RemoveFromStringList(msg))
                		{
                                	try{xml.LoadXml(msg);
                                		switch(xml.DocumentElement.Name){
                                        		case "LOGOUT":
                                                                if(((string)(xml.DocumentElement.GetAttribute("result"))).Equals("1")){
                                                        		lstFriend.Enabled=false;
	                        					txtChat.Enabled=false;
						                        btnChat.Enabled=false;
						                        txtStatus.Enabled=false;
						                        btnStatus.Enabled=false;
						                        txtFriend.Enabled=false;
						                        btnFriend.Enabled=false;
					        	                mnuItmLogOut.Enabled=false;
						                        mnuItmLogIn.Enabled=true;
        	                                                        m_comm.Abort();
						                        m_resendTimer.Change(Timeout.Infinite,Timeout.Infinite);
						                        m_resendTimer=null;
                                                                        int i=m_chatWindows.Count;
                                                                        for(;i<0;i--){
                                                                        	((Form)m_chatWindows[i]).Close();
                                                                                m_chatWindows.RemoveAt(i);
                                                                        }
                                                                        for(i=0;i<m_stringList.Length;i++){
                                                                        	m_stringList[i]=null;
                                                                        }
                                                                }
                                                                break;
                                                        case "MESSAGE":
                                                                if(xml.DocumentElement.GetAttribute("result")!=null){
                                                               		switch(xml.DocumentElement.GetAttribute("result")){
                                                                		case "-1":
                                                                       			MessageBox.Show("User is Offline. Message Will be received when they are next online.");
                                                                               		break;
                                                                        		case "0":
                                                                        			MessageBox.Show("The user does not exist or a general error occured. Please try again at a another time.","General Message Error");
                                                                                		break;
                                                                        		default:
                                                                        			break;
                                                                	}
                                                                }
                                                                else {
                                                                	//Find Chat windows add msg from user
                                                                        //If chat window does not exist create ,add to list and add message
                                                                }
                                                                break;
                                                        case "STATUS":
                                                               	switch(xml.DocumentElement.GetAttribute("type")){
                                                                       	case "set":
                                                                               	if(((string)xml.DocumentElement.GetAttribute("result")).Equals("1")){
                                                                                       	MessageBox.Show("Your Status was changed succesfully!");
                                                                                }
                                                                                else{
                                                                                	MessageBox.Show("Your Status did not change.");
                                                                                }
                                                                        	break;
                                                                        case "get":
                                                                        	if(((string)xml.DocumentElement.GetAttribute("result")).Equals("-1")){
                                                                                	MessageBox.Show("An Error Occured while trying to retrieve your status.");
                                                                                }
                                                                                else{
                                                                                	int i=0;
                                                                                        for(;!(((string)xml.DocumentElement.GetAttribute("result")).Equals(((StatusData)cmbStatus.Items[i]).mNum));i++);
                                                                                        txtStatus.Text=cmbStatus.Items[i].ToString();
                                                                                }

                                                                                break;


                                                                }
                                                                break;
                                                        case "STATUSLIST":
                                                                	XmlNodeList nodes=xml.DocumentElement.GetElementsByTagName("STATUS");
                                                                        IEnumerator ienum=nodes.GetEnumerator();
                                                                        while(ienum.MoveNext()){
                                                                        	XmlNode node=(XmlNode)ienum.Current;
                                                                                cmbStatus.Items.Add(new StatusData(node.Value,node.Attributes[0].ToString()));
                                                                        }
                                                               	break;
                                                        case "FRIEND":
                                                        	switch(xml.DocumentElement.GetAttribute("type")){
                                                                	case "add":
                                                                        	string res=xml.DocumentElement.GetAttribute("result");
                                                                                if(res.Equals("1"))
                                                                                	MessageBox.Show("The user has been sent an invite.");
                                                                                else
                                                                                	MessageBox.Show("The user could not have an invitation sent. Either the user does not exist or you already have this user or invited this user as a friend.");
                                                                                break;
                                                                        case "delete":
                                                                        	if(((string)xml.DocumentElement.GetAttribute("result")).Equals("1")){
                                                                                	MessageBox.Show("The User has been removed as a friend.");
                                                                                        SendToServer(@"<FRIEND type=""request"" user="""+m_user+@"""/>"+"\r\n",true);
                                                                                }
                                                                                else{
                                                                                	MessageBox.Show("The user has not been removed as a friend.");
                                                                                }
                                                                                break;
                                                                        case "request":
                                                                        	//Update Friends list
                                                                                XmlNodeList nodes2=xml.DocumentElement.GetElementsByTagName("USER");
                                                                        	IEnumerator ienum2=nodes2.GetEnumerator();
                                                                       	 	while(ienum2.MoveNext()){
                                                                        		XmlNode node2=(XmlNode)ienum2.Current;
                                                                                        int i=0;
                                                                                        string num=node2.Attributes[0].ToString();
                                                                                        for(;!num.Equals(((StatusData)(cmbStatus.Items[i])).mNum);i++)
                                                                                	lstFriend.Items.Add(new FriendData(node2.Value,cmbStatus.Items[i].ToString()));
                                                                        	}
                                                                                break;
                                                                        case "invite":
                                                                        	if(xml.DocumentElement.GetAttribute("result")==null){
                                                                        		if(m_user.Equals(xml.DocumentElement.GetAttribute("friend")))
                                                                                		if(MessageBox.Show("You have been invited to become friends with '"+xml.DocumentElement.GetAttribute("user")+"'.\n\nDo you want to become friends with this user?","Friend Invite Received",MessageBoxButtons.YesNo,MessageBoxIcon.Question)==DialogResult.Yes){
                                                                                                	SendToServer(@"<FRIEND type=""accept"" user="""+xml.DocumentElement.GetAttribute("user")+ @""" other="""+m_user+@"""/>"+"\r\n",true);
                                                                                        	}
                                                                                        	else{
                                                                                                	SendToServer(@"<FRIEND type=""deny"" user="""+xml.DocumentElement.GetAttribute("user")+@""" other="""+m_user+@"""/>"+"\r\n",true);
                                                                                        	}

                                                                                }
                                                                                else
                                                                                {
                                                                                	SendToServer(@"<FRIEND type=""request"" user="""+m_user+@"""/>"+"\r\n",true);


                                                                                }
                                                                                break;



                                        		}
                                                        break;
                                        	}
                                        }


                                        catch(XmlException xe){
                                        			MessageBox.Show(xe.ToString());
                                        }
                        	}
                	}
                }
                private void AddToStringList(string itm){
                	int i=0;
                        for(;i<m_stringList.Length||m_stringList[i].Equals(itm);i++);
                        if(i>=m_stringList.Length){
                        	MessageBox.Show("The list of unreplied messages is too long. Cannot check the validity of messages.");
                        }
                        else {
                        	m_stringList[i]=itm;
                        }
                }
                private bool RemoveFromStringList(string itm){
                	int i=0;
                        for(;i<m_stringList.Length||itm.Equals(m_stringList[i]);i++);
                        if(i>=m_stringList.Length)
                        	return false;
                        else{
                        	m_stringList[i]=null;
                                return true;
                        }
                }
                private void ReSendMessage(object o){
                	int i=0;
                        for(;i<m_stringList.Length;i++){
                        	if(m_stringList[i]!=null)
                                	SendToServer(m_stringList[i],false);
                        }
                }
                public void RemoveChatWindow(WinForm1 frm){
                	m_chatWindows.Remove(frm);
                }
                private WinForm1 FindChatWindow(string user){
                	m_chatWindows.TrimToSize();
                	WinForm1[] frms=(WinForm1 [])m_chatWindows.ToArray();
                	int i=0;
                	for(;i<frms.Length;i++)
                		if(frms[i].Name.Equals("Chatting with: "+user))
                        		return frms[i];
	                return null;
                }

		private void mnItmLogIn_Click(object sender, System.EventArgs e) {

                        RegistryKey key=Registry.LocalMachine;
                        key=key.OpenSubKey("Software\\BazSoft\\MSGClient");
                        WinForm3 frm2=new WinForm3();
                        if(key==null){
                        	frm2.ShowDialog();
                                key=Registry.LocalMachine.OpenSubKey("Software\\BazSoft\\MSGClient");
                        }
                        string server = key.GetValue("Server").ToString();
                        if(server==null){
                        	frm2.ShowDialog();
				server = key.GetValue("Server").ToString();
                        }
                        bool repeat=true;
                        while(repeat){
                        	try{IPAddress ip=IPAddress.Parse(server);
                                	m_client = new Socket(ip.AddressFamily,SocketType.Stream,ProtocolType.Tcp);
                                	IPEndPoint ep=new IPEndPoint(ip,31423);
                          		m_client.Connect(ep);
                                        repeat=false;
                        	}
                        	catch(Exception e3){
                        		try{IPAddress ip =Dns.Resolve(server).AddressList[0];
                                        m_client = new Socket(ip.AddressFamily,SocketType.Stream,ProtocolType.Tcp);
                                	IPEndPoint ep=new IPEndPoint(ip,31423);
                          		m_client.Connect(ep);}
                        		catch (Exception e2){
                                		if(MessageBox.Show("The client cannot connect to the server. Make sure the Internet or Local Network is connected and working. Click OK to try again.\n\nIf you are having trouble connecting to the server please click on '' and re-enter the server configuration.","ERROR: Cannot Connect to Server",MessageBoxButtons.OKCancel,MessageBoxIcon.Error)==DialogResult.Cancel){
                                                	frm2 = new WinForm3();
                                                        frm2.ShowDialog();
							server = key.GetValue("Server").ToString();
                                                }
                               	 	}
                        	}
                        }
                        WinForm2 frm = new WinForm2();
                        frm.SetSocket(m_client);
                        if(frm.ShowDialog()==DialogResult.OK){
                        m_user=frm.GetUser();
                        lstFriend.Enabled=true;
                        txtChat.Enabled=true;
                        btnChat.Enabled=true;
                        txtStatus.Enabled=true;
                        btnStatus.Enabled=true;
                        cmbStatus.Enabled=true;
                        txtFriend.Enabled=true;
                        btnFriend.Enabled=true;
                        mnuItmLogOut.Enabled=true;
                        mnuItmLogIn.Enabled=false;
                        btnRemFriend.Enabled=true;
			m_comm=new Thread(new ThreadStart(CommReceive));
                        m_resendTimer = new System.Threading.Timer(new TimerCallback(ReSendMessage),null,1000,15000);

                        SendToServer(@"<FRIEND type=""REQUEST""\>"+"\r\n",true);
                        SendToServer(@"<STATUS type=""list""\>"+"\r\n",true);
                        SendToServer(@"<STATUS type=""get"" name="""+m_user+@"""/>"+"\r\n",true);
                        }
		}

		private void mnuItmLogOut_Click(object sender, System.EventArgs e) {
                        SendToServer(@"<LOGOUT user="""+m_user+@"""/>"+"\r\n",true);
                }

		private void btnFriend_Click(object sender, System.EventArgs e) {
                        SendToServer(@"<FRIEND type=""add"" user="""+m_user+@""" friend="""+txtFriend.Text+@"""/>"+"\r\n",true);
		}

		private void btnStatus_Click(object sender, System.EventArgs e) {
                	SendToServer(@"<STATUS user="""+m_user+@"""type=""set"" code="""+((StatusData)cmbStatus.SelectedItem).mNum+@"""/>"+"\r\n",true);
                	SendToServer(@"<STATUS user="""+m_user+@"""type=""get""/>"+"\r\n",true);
		}




		private void btnChat_Click(object sender, System.EventArgs e) {
			string user=txtChat.Text;
                        if(FindChatWindow(user)!=null){
                        	MessageBox.Show("There is already a chat window for this user. Please use that.");}
                        else {
                        	WinForm1 frm = new WinForm1();
                                frm.Name="Chatting with: "+user;
                                frm.SetUser(user);
                                frm.TopMost=true;
                                frm.Show();
                                m_chatWindows.Add(frm);
                        }

		}

		private void btnRemFriend_Click1(object sender, System.EventArgs e) {
			if(lstFriend.SelectedItem!=null){
                        	SendToServer(@"<FRIEND type=""delete"" user="""+m_user+@""" friend="""+lstFriend.SelectedItem.ToString()+@"""/>"+"\r\n",true);
                        }
		}
                private void KeepAlive(object o){
                	SendToServer("<ALIVE/>\r\n",false);
                }
        }
}

